#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
### 2004-0421 - Quikview v.0.1 mod by catastrophe (initial release)
# - Intended for use on Smoothwall Express 2.0 p2 ui-3.6.1
# - Implementation of v2.1 pack system by Tiago Freitas Leal 
# - Truncate long lines inspired by routine from conntrack-viewer-KH.pl modifications by Venables
### 2004-0509 - Quikview v.0.2 mod by catastrophe
# - External default and custom file lists
# - Added "line numbers"
# - Improved truncation accuracy
### 2004-0919 - Quikview v.0.3 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 p4 ui-3.6.1
# - Added "tail" to view last 10 lines
# - Added selectable page refresh rate (0ff,30s,300s,600s,1800s,3600s)
#    (borrowed "improved page refresh code" by Daniel Hokka Zakrisson from Connview v.0.6)
# - Added "reverse output" to display the last lines first
# - Added "jump to bottom" and "jump to top" for files greater than 30 lines 
###2004-1006 - quikview.cgi v.0.3.1-test1 by catastrophe for use with Quikview v.0.3
# - Added "page generated in 'x' seconds" (thanks daniel_hozac)
# - Added 'hide alertbox' variable
#
# Future plans:
# - Not sure. Let us know!
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###

############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

my (%quikviewsettings,%checked);


$quikviewFILELIST[0] = "none";
$quikviewFILELIST[1] = "/var/smoothwall/preferences/quikview-default";
$quikviewFILELIST[2] = "/var/smoothwall/preferences/quikview-custom";
#$quikviewFILELIST[3] = "/var/smoothwall/preferences/quikview-custom2";
#$quikviewFILELIST[4] = "/var/smoothwall/preferences/quikview-custom3";



##########
###MENU###
##########

#&showhttpheaders();

$quikviewsettings{'ACTION'} = '';
$quikviewsettings{'QUIK_LIST'} = 'none';
$quikviewsettings{'QUIK_FILE'} = 'none';
$quikviewsettings{'QUIK_REFRESH'} = '0';
$quikviewsettings{'QUIK_TAIL'} = 'off';
$quikviewsettings{'QUIK_NUMBER'} = 'off';
$quikviewsettings{'QUIK_TRUNCATE'} = 'off';
$quikviewsettings{'QUIK_REVERSE'} = 'off';
$quikviewsettings{'QUIK_TAIL_LINES'} = '10';
$quikviewsettings{'QUIK_JUMP_LINES'} = '30';
$quikviewsettings{'QUIK_HIDE_ALERTBOX'} = 'off';
&getcgihash(\%quikviewsettings);

my $errormessage = '';

if ($quikviewsettings{'ACTION'} eq $tr{'update'})
{
	&writehash("${swroot}/preferences/quikview", \%quikviewsettings);
}

system ("/bin/touch ${swroot}/preferences/quikview");
&readhash("${swroot}/preferences/quikview", \%quikviewsettings);

for ($i=1; $i <= $#quikviewFILELIST; $i++){
	$selected{'QUIK_LIST'}{$quikviewFILELIST[$i]} = '';
}
$selected{'QUIK_LIST'}{$quikviewsettings{'QUIK_LIST'}} = 'SELECTED';

&quikviewGETfilenames();

for ($i=1; $i <= $#quikviewFILENAME; $i++){
	$selected{'QUIK_FILE'}{$quikviewFILENAME[$i]} = '';
}
$selected{'QUIK_FILE'}{$quikviewsettings{'QUIK_FILE'}} = 'SELECTED';

$selected{'QUIK_REFRESH'}{'0'} = '';
$selected{'QUIK_REFRESH'}{'5'} = '';
$selected{'QUIK_REFRESH'}{'10'} = '';
$selected{'QUIK_REFRESH'}{'30'} = '';
$selected{'QUIK_REFRESH'}{'60'} = '';
$selected{'QUIK_REFRESH'}{'120'} = '';
$selected{'QUIK_REFRESH'}{'300'} = '';
$selected{'QUIK_REFRESH'}{'600'} = '';
$selected{'QUIK_REFRESH'}{'1800'} = '';
$selected{'QUIK_REFRESH'}{'3600'} = '';
$selected{'QUIK_REFRESH'}{$quikviewsettings{'QUIK_REFRESH'}} = 'SELECTED';

$checked{'QUIK_TAIL'}{'on'} = '';
$checked{'QUIK_TAIL'}{'off'} = '';
$checked{'QUIK_TAIL'}{$quikviewsettings{'QUIK_TAIL'}} = 'CHECKED';

$checked{'QUIK_NUMBER'}{'on'} = '';
$checked{'QUIK_NUMBER'}{'off'} = '';
$checked{'QUIK_NUMBER'}{$quikviewsettings{'QUIK_NUMBER'}} = 'CHECKED';

$checked{'QUIK_TRUNCATE'}{'on'} = '';
$checked{'QUIK_TRUNCATE'}{'off'} = '';
$checked{'QUIK_TRUNCATE'}{$quikviewsettings{'QUIK_TRUNCATE'}} = 'CHECKED';

$checked{'QUIK_REVERSE'}{'on'} = '';
$checked{'QUIK_REVERSE'}{'off'} = '';
$checked{'QUIK_REVERSE'}{$quikviewsettings{'QUIK_REVERSE'}} = 'CHECKED';

&quikviewREFRESHset();

#&openpage($tr{'quik quikviewinfo'}, 1, '', 'logs');

&showlogssection();

&openbigbox('100%', 'LEFT');

if ($quikviewsettings{'QUIK_HIDE_ALERTBOX'} eq 'on') {
	###then do nothing
} else {
	&alertbox($errormessage);
}

print "<FORM METHOD='POST'>\n";
&openbox('100%', 'LEFT');

print qq|
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
<TD CLASS='base'>$tr{'quik displayc'}
<SELECT NAME='QUIK_LIST'>
       <OPTION VALUE='$quikviewFILELIST[0]' $selected{'QUIK_LIST'}{$quikviewFILELIST[0]}>None
       <OPTION VALUE='$quikviewFILELIST[1]' $selected{'QUIK_LIST'}{$quikviewFILELIST[1]}>Default
       <OPTION VALUE='$quikviewFILELIST[2]' $selected{'QUIK_LIST'}{$quikviewFILELIST[2]}>Custom
</SELECT>
</TD>
|;

print "<TD CLASS='base'>$tr{'quik filec'}";
print "<SELECT NAME='QUIK_FILE'>";
print "<OPTION VALUE='$quikviewFILENAME[0]' $selected{'QUIK_FILE'}{$quikviewFILENAME[0]}>None";
for ($i=1; $i <= $#quikviewFILENAME; $i++){
	print "<OPTION VALUE='$quikviewFILENAME[$i]' $selected{'QUIK_FILE'}{$quikviewFILENAME[$i]}>$quikviewFILENAME[$i]";
}
print "</SELECT></TD>";

print qq|
<TD CLASS='base'>$tr{'quik refreshc'}
<SELECT NAME='QUIK_REFRESH'>
	<OPTION VALUE='0' $selected{'QUIK_REFRESH'}{'0'}>Off
	<OPTION VALUE='30' $selected{'QUIK_REFRESH'}{'30'}>30s
	<OPTION VALUE='300' $selected{'QUIK_REFRESH'}{'300'}>300s
	<OPTION VALUE='600' $selected{'QUIK_REFRESH'}{'600'}>600s
	<OPTION VALUE='1800' $selected{'QUIK_REFRESH'}{'1800'}>1800s
	<OPTION VALUE='3600' $selected{'QUIK_REFRESH'}{'3600'}>3600s
</SELECT>
</TD>

<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'update'}'></TD> 
</TR>
|;

print qq|
<TR>

<TD>&nbsp;</TD>

<TD CLASS='base'>$tr{'quik tailc'}
<INPUT TYPE='checkbox' NAME='QUIK_TAIL' $checked{'QUIK_TAIL'}{'on'}>

$tr{'quik numberc'}
<INPUT TYPE='checkbox' NAME='QUIK_NUMBER' $checked{'QUIK_NUMBER'}{'on'}>

$tr{'quik truncatec'}
<INPUT TYPE='checkbox' NAME='QUIK_TRUNCATE' $checked{'QUIK_TRUNCATE'}{'on'}>

$tr{'quik reversec'}
<INPUT TYPE='checkbox' NAME='QUIK_REVERSE' $checked{'QUIK_REVERSE'}{'on'}></TD>

</TR>
</TABLE>
|;

print "</FORM>\n";
&closebox();

##########
###MAIN###
##########

&quikviewDISPLAY();

&closebigbox();
&closepage();

$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";

##########
###DONE###
##########





#################
###SUBROUTINES###
#################

sub quikviewGETfilenames {
	@quikviewFILENAME = `cat $quikviewsettings{'QUIK_LIST'}`;
	chomp (@quikviewFILENAME);
}


sub quikviewREFRESHset {
	my $refresh = $quikviewsettings{'QUIK_REFRESH'};
	if ($refresh > 0)
	{
		print "Refresh: $refresh\n";
		print "Cache-Control: no-cache\n";
		print "Pragma: no-cache\n";
	}
	&showhttpheaders();
$t0 = gettimeofday();
	&openpage($tr{'quik quikviewinfo'}, 1, '', 'logs');
}


sub quikviewDISPLAY {

	if ($quikviewsettings{QUIK_FILE} eq "") { 
		$quikviewsettings{'QUIK_FILE'} = 'none'; 
	} elsif ($quikviewsettings{QUIK_LIST} eq "none") {
		$quikviewsettings{'QUIK_FILE'} = 'none'; 
	}

	if ($quikviewsettings{QUIK_LIST} eq "none"){   
       	###then do nothing
	} else {

		if ($quikviewsettings{QUIK_FILE} eq "none") {   
       		###then do nothing
		} else {
			print qq|
			<a name="top"></a>			
			|;

			&openbox('100%', 'LEFT', $quikviewsettings{'QUIK_FILE'});

			if ($quikviewsettings{QUIK_TAIL} eq "on") {
#				@quik = `tail $quikviewsettings{'QUIK_FILE'}`;
				@quik = `tail -n $quikviewsettings{'QUIK_TAIL_LINES'} $quikviewsettings{'QUIK_FILE'}`;
			} else {
				@quik = `cat $quikviewsettings{'QUIK_FILE'}`;
				
				if ($#quik > $quikviewsettings{'QUIK_JUMP_LINES'}) {
					print qq|
					<CENTER><a href="#bottom">$tr{'quik godown'}</a></CENTER>
					|;
				}
			}

			print "<DIV align='left'><PRE>";

			if ($quikviewsettings{QUIK_REVERSE} eq "on") {  
				for ($i=$#quik; $i >= 0; $i--){
					&quikviewPARSEandPRINT();
				}
			} else { 
				for ($i=0; $i <= $#quik; $i++){
					&quikviewPARSEandPRINT();
				}
			}
			print "</PRE></DIV>";

			if ($quikviewsettings{QUIK_TAIL} eq "on") {
				###then do nothing
			} elsif ($#quik > $quikviewsettings{'QUIK_JUMP_LINES'}) {
				print qq|
				<a name="bottom"></a><CENTER><a href="#top">$tr{'quik goup'}</a></CENTER>
				<BR>
				|;
			}

			&closebox();
		}
	}
}


sub quikviewPARSEandPRINT {
		$quikline = $quik[$i];
		&quikviewLINEnumbers();
		chomp ($quikline);
		$quikline =~ s/\t/:D:P:D:P/g;	### change \t to :D:P:D:P so tabs counted accurately

		if ($quikviewsettings{QUIK_TRUNCATE} eq "on"){
			if (length($quikline) > 122) {$quikline = ( substr $quikline, 0, 119 )."...";};
   		}

		$quikline =~ s/&/&amp;/g;		### change & to &amp;
		$quikline =~ s/"/&quot;/g; 		### change " to &quot;
		$quikline =~ s/>/&gt;/g; 		### change > to &gt;
		$quikline =~ s/</&lt;/g; 		### change < to &lt;		
#		$quikline =~ s/ /&nbsp;/g;		### display spaces
		$quikline =~ s/:D:P:D:P/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/g;	### display tabs

		print "$quikline\n";
}


sub quikviewLINEnumbers {
	$quikspace="";

	if ($quikviewsettings{QUIK_NUMBER} eq "on") {
		for ($nbspace=0; $nbspace<((length $#quik)-(length $i)); $nbspace=$nbspace+1) { 
			$quikspace=$quikspace." "; 
		}
		$quikline = "$quikspace$i   $quik[$i]";
	} else {
		$quikline = "$quik[$i]";
	}
}
